/**
 * @name array-of-arrays-into-ast
 * @fileoverview Turns an array of arrays of data into a nested tree of plain objects
 * @version 4.0.6
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/array-of-arrays-into-ast/}
 */

"use strict";var arrayOfArraysIntoAst=(()=>{var Ft=Object.create;var P=Object.defineProperty,Kt=Object.defineProperties,Nt=Object.getOwnPropertyDescriptor,Rt=Object.getOwnPropertyDescriptors,Lt=Object.getOwnPropertyNames,xe=Object.getOwnPropertySymbols,Ut=Object.getPrototypeOf,we=Object.prototype.hasOwnProperty,Gt=Object.prototype.propertyIsEnumerable;var Se=(e,t,r)=>t in e?P(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,d=(e,t)=>{for(var r in t||(t={}))we.call(t,r)&&Se(e,r,t[r]);if(xe)for(var r of xe(t))Gt.call(t,r)&&Se(e,r,t[r]);return e},R=(e,t)=>Kt(e,Rt(t));var L=(e,t)=>()=>(t||e((t={exports:{}}).exports,t),t.exports),Vt=(e,t)=>{for(var r in t)P(e,r,{get:t[r],enumerable:!0})},Te=(e,t,r,n)=>{if(t&&typeof t=="object"||typeof t=="function")for(let o of Lt(t))!we.call(e,o)&&o!==r&&P(e,o,{get:()=>t[o],enumerable:!(n=Nt(t,o))||n.enumerable});return e};var U=(e,t,r)=>(r=e!=null?Ft(Ut(e)):{},Te(t||!e||!e.__esModule?P(r,"default",{value:e,enumerable:!0}):r,e)),Ht=e=>Te(P({},"__esModule",{value:!0}),e);var bt=L((D,C)=>{var Wt=200,Re="__lodash_hash_undefined__",Le=9007199254740991,se="[object Arguments]",Qt="[object Array]",Ue="[object Boolean]",Ge="[object Date]",Jt="[object Error]",ce="[object Function]",Ve="[object GeneratorFunction]",G="[object Map]",He="[object Number]",ue="[object Object]",Ce="[object Promise]",We="[object RegExp]",V="[object Set]",Qe="[object String]",Je="[object Symbol]",te="[object WeakMap]",qe="[object ArrayBuffer]",H="[object DataView]",Xe="[object Float32Array]",Ze="[object Float64Array]",Ye="[object Int8Array]",ze="[object Int16Array]",et="[object Int32Array]",tt="[object Uint8Array]",rt="[object Uint8ClampedArray]",nt="[object Uint16Array]",it="[object Uint32Array]",qt=/[\\^$.*+?()[\]{}|]/g,Xt=/\w*$/,Zt=/^\[object .+?Constructor\]$/,Yt=/^(?:0|[1-9]\d*)$/,y={};y[se]=y[Qt]=y[qe]=y[H]=y[Ue]=y[Ge]=y[Xe]=y[Ze]=y[Ye]=y[ze]=y[et]=y[G]=y[He]=y[ue]=y[We]=y[V]=y[Qe]=y[Je]=y[tt]=y[rt]=y[nt]=y[it]=!0;y[Jt]=y[ce]=y[te]=!1;var zt=typeof global=="object"&&global&&global.Object===Object&&global,er=typeof self=="object"&&self&&self.Object===Object&&self,O=zt||er||Function("return this")(),at=typeof D=="object"&&D&&!D.nodeType&&D,Ee=at&&typeof C=="object"&&C&&!C.nodeType&&C,tr=Ee&&Ee.exports===at;function rr(e,t){return e.set(t[0],t[1]),e}function nr(e,t){return e.add(t),e}function ir(e,t){for(var r=-1,n=e?e.length:0;++r<n&&t(e[r],r,e)!==!1;);return e}function ar(e,t){for(var r=-1,n=t.length,o=e.length;++r<n;)e[o+r]=t[r];return e}function ot(e,t,r,n){var o=-1,i=e?e.length:0;for(n&&i&&(r=e[++o]);++o<i;)r=t(r,e[o],o,e);return r}function or(e,t){for(var r=-1,n=Array(e);++r<e;)n[r]=t(r);return n}function sr(e,t){return e==null?void 0:e[t]}function st(e){var t=!1;if(e!=null&&typeof e.toString!="function")try{t=!!(e+"")}catch(r){}return t}function $e(e){var t=-1,r=Array(e.size);return e.forEach(function(n,o){r[++t]=[o,n]}),r}function fe(e,t){return function(r){return e(t(r))}}function Me(e){var t=-1,r=Array(e.size);return e.forEach(function(n){r[++t]=n}),r}var cr=Array.prototype,ur=Function.prototype,W=Object.prototype,ee=O["__core-js_shared__"],Ie=function(){var e=/[^.]+$/.exec(ee&&ee.keys&&ee.keys.IE_PROTO||"");return e?"Symbol(src)_1."+e:""}(),ct=ur.toString,j=W.hasOwnProperty,Q=W.toString,fr=RegExp("^"+ct.call(j).replace(qt,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),Pe=tr?O.Buffer:void 0,De=O.Symbol,Be=O.Uint8Array,pr=fe(Object.getPrototypeOf,Object),lr=Object.create,yr=W.propertyIsEnumerable,hr=cr.splice,Fe=Object.getOwnPropertySymbols,gr=Pe?Pe.isBuffer:void 0,br=fe(Object.keys,Object),re=M(O,"DataView"),B=M(O,"Map"),ne=M(O,"Promise"),ie=M(O,"Set"),ae=M(O,"WeakMap"),F=M(Object,"create"),dr=T(re),mr=T(B),Ar=T(ne),_r=T(ie),Or=T(ae),Ke=De?De.prototype:void 0,Ne=Ke?Ke.valueOf:void 0;function w(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function kr(){this.__data__=F?F(null):{}}function jr(e){return this.has(e)&&delete this.__data__[e]}function vr(e){var t=this.__data__;if(F){var r=t[e];return r===Re?void 0:r}return j.call(t,e)?t[e]:void 0}function xr(e){var t=this.__data__;return F?t[e]!==void 0:j.call(t,e)}function Sr(e,t){var r=this.__data__;return r[e]=F&&t===void 0?Re:t,this}w.prototype.clear=kr;w.prototype.delete=jr;w.prototype.get=vr;w.prototype.has=xr;w.prototype.set=Sr;function k(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function wr(){this.__data__=[]}function Tr(e){var t=this.__data__,r=J(t,e);if(r<0)return!1;var n=t.length-1;return r==n?t.pop():hr.call(t,r,1),!0}function Cr(e){var t=this.__data__,r=J(t,e);return r<0?void 0:t[r][1]}function Er(e){return J(this.__data__,e)>-1}function $r(e,t){var r=this.__data__,n=J(r,e);return n<0?r.push([e,t]):r[n][1]=t,this}k.prototype.clear=wr;k.prototype.delete=Tr;k.prototype.get=Cr;k.prototype.has=Er;k.prototype.set=$r;function E(e){var t=-1,r=e?e.length:0;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function Mr(){this.__data__={hash:new w,map:new(B||k),string:new w}}function Ir(e){return q(this,e).delete(e)}function Pr(e){return q(this,e).get(e)}function Dr(e){return q(this,e).has(e)}function Br(e,t){return q(this,e).set(e,t),this}E.prototype.clear=Mr;E.prototype.delete=Ir;E.prototype.get=Pr;E.prototype.has=Dr;E.prototype.set=Br;function $(e){this.__data__=new k(e)}function Fr(){this.__data__=new k}function Kr(e){return this.__data__.delete(e)}function Nr(e){return this.__data__.get(e)}function Rr(e){return this.__data__.has(e)}function Lr(e,t){var r=this.__data__;if(r instanceof k){var n=r.__data__;if(!B||n.length<Wt-1)return n.push([e,t]),this;r=this.__data__=new E(n)}return r.set(e,t),this}$.prototype.clear=Fr;$.prototype.delete=Kr;$.prototype.get=Nr;$.prototype.has=Rr;$.prototype.set=Lr;function Ur(e,t){var r=le(e)||yn(e)?or(e.length,String):[],n=r.length,o=!!n;for(var i in e)(t||j.call(e,i))&&!(o&&(i=="length"||un(i,n)))&&r.push(i);return r}function ut(e,t,r){var n=e[t];(!(j.call(e,t)&&yt(n,r))||r===void 0&&!(t in e))&&(e[t]=r)}function J(e,t){for(var r=e.length;r--;)if(yt(e[r][0],t))return r;return-1}function Gr(e,t){return e&&ft(t,ye(t),e)}function oe(e,t,r,n,o,i,a){var u;if(n&&(u=i?n(e,o,i,a):n(e)),u!==void 0)return u;if(!X(e))return e;var l=le(e);if(l){if(u=on(e),!t)return rn(e,u)}else{var b=S(e),A=b==ce||b==Ve;if(gn(e))return qr(e,t);if(b==ue||b==se||A&&!i){if(st(e))return i?e:{};if(u=sn(A?{}:e),!t)return nn(e,Gr(u,e))}else{if(!y[b])return i?e:{};u=cn(e,b,oe,t)}}a||(a=new $);var f=a.get(e);if(f)return f;if(a.set(e,u),!l)var s=r?an(e):ye(e);return ir(s||e,function(h,p){s&&(p=h,h=e[p]),ut(u,p,oe(h,t,r,n,p,e,a))}),u}function Vr(e){return X(e)?lr(e):{}}function Hr(e,t,r){var n=t(e);return le(e)?n:ar(n,r(e))}function Wr(e){return Q.call(e)}function Qr(e){if(!X(e)||pn(e))return!1;var t=gt(e)||st(e)?fr:Zt;return t.test(T(e))}function Jr(e){if(!lt(e))return br(e);var t=[];for(var r in Object(e))j.call(e,r)&&r!="constructor"&&t.push(r);return t}function qr(e,t){if(t)return e.slice();var r=new e.constructor(e.length);return e.copy(r),r}function pe(e){var t=new e.constructor(e.byteLength);return new Be(t).set(new Be(e)),t}function Xr(e,t){var r=t?pe(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.byteLength)}function Zr(e,t,r){var n=t?r($e(e),!0):$e(e);return ot(n,rr,new e.constructor)}function Yr(e){var t=new e.constructor(e.source,Xt.exec(e));return t.lastIndex=e.lastIndex,t}function zr(e,t,r){var n=t?r(Me(e),!0):Me(e);return ot(n,nr,new e.constructor)}function en(e){return Ne?Object(Ne.call(e)):{}}function tn(e,t){var r=t?pe(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.length)}function rn(e,t){var r=-1,n=e.length;for(t||(t=Array(n));++r<n;)t[r]=e[r];return t}function ft(e,t,r,n){r||(r={});for(var o=-1,i=t.length;++o<i;){var a=t[o],u=n?n(r[a],e[a],a,r,e):void 0;ut(r,a,u===void 0?e[a]:u)}return r}function nn(e,t){return ft(e,pt(e),t)}function an(e){return Hr(e,ye,pt)}function q(e,t){var r=e.__data__;return fn(t)?r[typeof t=="string"?"string":"hash"]:r.map}function M(e,t){var r=sr(e,t);return Qr(r)?r:void 0}var pt=Fe?fe(Fe,Object):mn,S=Wr;(re&&S(new re(new ArrayBuffer(1)))!=H||B&&S(new B)!=G||ne&&S(ne.resolve())!=Ce||ie&&S(new ie)!=V||ae&&S(new ae)!=te)&&(S=function(e){var t=Q.call(e),r=t==ue?e.constructor:void 0,n=r?T(r):void 0;if(n)switch(n){case dr:return H;case mr:return G;case Ar:return Ce;case _r:return V;case Or:return te}return t});function on(e){var t=e.length,r=e.constructor(t);return t&&typeof e[0]=="string"&&j.call(e,"index")&&(r.index=e.index,r.input=e.input),r}function sn(e){return typeof e.constructor=="function"&&!lt(e)?Vr(pr(e)):{}}function cn(e,t,r,n){var o=e.constructor;switch(t){case qe:return pe(e);case Ue:case Ge:return new o(+e);case H:return Xr(e,n);case Xe:case Ze:case Ye:case ze:case et:case tt:case rt:case nt:case it:return tn(e,n);case G:return Zr(e,n,r);case He:case Qe:return new o(e);case We:return Yr(e);case V:return zr(e,n,r);case Je:return en(e)}}function un(e,t){return t=t==null?Le:t,!!t&&(typeof e=="number"||Yt.test(e))&&e>-1&&e%1==0&&e<t}function fn(e){var t=typeof e;return t=="string"||t=="number"||t=="symbol"||t=="boolean"?e!=="__proto__":e===null}function pn(e){return!!Ie&&Ie in e}function lt(e){var t=e&&e.constructor,r=typeof t=="function"&&t.prototype||W;return e===r}function T(e){if(e!=null){try{return ct.call(e)}catch(t){}try{return e+""}catch(t){}}return""}function ln(e){return oe(e,!0,!0)}function yt(e,t){return e===t||e!==e&&t!==t}function yn(e){return hn(e)&&j.call(e,"callee")&&(!yr.call(e,"callee")||Q.call(e)==se)}var le=Array.isArray;function ht(e){return e!=null&&bn(e.length)&&!gt(e)}function hn(e){return dn(e)&&ht(e)}var gn=gr||An;function gt(e){var t=X(e)?Q.call(e):"";return t==ce||t==Ve}function bn(e){return typeof e=="number"&&e>-1&&e%1==0&&e<=Le}function X(e){var t=typeof e;return!!e&&(t=="object"||t=="function")}function dn(e){return!!e&&typeof e=="object"}function ye(e){return ht(e)?Ur(e):Jr(e)}function mn(){return[]}function An(){return!1}C.exports=ln});var kt=L((Ei,Ot)=>{var dt=1/0,At=9007199254740991,_n=17976931348623157e292,mt=0/0,On="[object Arguments]",kn="[object Function]",jn="[object GeneratorFunction]",vn="[object String]",xn="[object Symbol]",Sn=/^\s+|\s+$/g,wn=/^[-+]0x[0-9a-f]+$/i,Tn=/^0b[01]+$/i,Cn=/^0o[0-7]+$/i,En=/^(?:0|[1-9]\d*)$/,$n=parseInt;function Mn(e,t){for(var r=-1,n=e?e.length:0,o=Array(n);++r<n;)o[r]=t(e[r],r,e);return o}function In(e,t,r,n){for(var o=e.length,i=r+(n?1:-1);n?i--:++i<o;)if(t(e[i],i,e))return i;return-1}function Pn(e,t,r){if(t!==t)return In(e,Dn,r);for(var n=r-1,o=e.length;++n<o;)if(e[n]===t)return n;return-1}function Dn(e){return e!==e}function Bn(e,t){for(var r=-1,n=Array(e);++r<e;)n[r]=t(r);return n}function Fn(e,t){return Mn(t,function(r){return e[r]})}function Kn(e,t){return function(r){return e(t(r))}}var Z=Object.prototype,ge=Z.hasOwnProperty,Y=Z.toString,Nn=Z.propertyIsEnumerable,Rn=Kn(Object.keys,Object),Ln=Math.max;function Un(e,t){var r=_t(e)||Qn(e)?Bn(e.length,String):[],n=r.length,o=!!n;for(var i in e)(t||ge.call(e,i))&&!(o&&(i=="length"||Vn(i,n)))&&r.push(i);return r}function Gn(e){if(!Hn(e))return Rn(e);var t=[];for(var r in Object(e))ge.call(e,r)&&r!="constructor"&&t.push(r);return t}function Vn(e,t){return t=t==null?At:t,!!t&&(typeof e=="number"||En.test(e))&&e>-1&&e%1==0&&e<t}function Hn(e){var t=e&&e.constructor,r=typeof t=="function"&&t.prototype||Z;return e===r}function Wn(e,t,r,n){e=be(e)?e:ni(e),r=r&&!n?ei(r):0;var o=e.length;return r<0&&(r=Ln(o+r,0)),Zn(e)?r<=o&&e.indexOf(t,r)>-1:!!o&&Pn(e,t,r)>-1}function Qn(e){return Jn(e)&&ge.call(e,"callee")&&(!Nn.call(e,"callee")||Y.call(e)==On)}var _t=Array.isArray;function be(e){return e!=null&&Xn(e.length)&&!qn(e)}function Jn(e){return de(e)&&be(e)}function qn(e){var t=he(e)?Y.call(e):"";return t==kn||t==jn}function Xn(e){return typeof e=="number"&&e>-1&&e%1==0&&e<=At}function he(e){var t=typeof e;return!!e&&(t=="object"||t=="function")}function de(e){return!!e&&typeof e=="object"}function Zn(e){return typeof e=="string"||!_t(e)&&de(e)&&Y.call(e)==vn}function Yn(e){return typeof e=="symbol"||de(e)&&Y.call(e)==xn}function zn(e){if(!e)return e===0?e:0;if(e=ti(e),e===dt||e===-dt){var t=e<0?-1:1;return t*_n}return e===e?e:0}function ei(e){var t=zn(e),r=t%1;return t===t?r?t-r:t:0}function ti(e){if(typeof e=="number")return e;if(Yn(e))return mt;if(he(e)){var t=typeof e.valueOf=="function"?e.valueOf():e;e=he(t)?t+"":t}if(typeof e!="string")return e===0?e:+e;e=e.replace(Sn,"");var r=Tn.test(e);return r||Cn.test(e)?$n(e.slice(2),r?2:8):wn.test(e)?mt:+e}function ri(e){return be(e)?Un(e):Gn(e)}function ni(e){return e?Fn(e,ri(e)):[]}Ot.exports=Wn});var Tt=L((K,I)=>{var ii="[object Date]",ai=typeof global=="object"&&global&&global.Object===Object&&global,wt=typeof K=="object"&&K&&!K.nodeType&&K,jt=wt&&typeof I=="object"&&I&&!I.nodeType&&I,oi=jt&&jt.exports===wt,vt=oi&&ai.process,xt=function(){try{return vt&&vt.binding("util")}catch(e){}}(),St=xt&&xt.isDate;function si(e){return function(t){return e(t)}}var ci=Object.prototype,ui=ci.toString;function fi(e){return li(e)&&ui.call(e)==ii}var pi=St?si(St):fi;function li(e){return!!e&&typeof e=="object"}I.exports=pi});var Et=L((Mi,Ct)=>{var yi=typeof global=="object"&&global&&global.Object===Object&&global,hi=typeof self=="object"&&self&&self.Object===Object&&self,gi=yi||hi||Function("return this")(),bi=gi.isFinite;function di(e){return typeof e=="number"&&bi(e)}Ct.exports=di});var Ti={};Vt(Ti,{defaults:()=>Bt,generateAst:()=>wi,version:()=>xi});var c=U(bt(),1),It=U(kt(),1);function m(e){if(e==null||typeof e!="object")return!1;let t=Object.getPrototypeOf(e);return t!==null&&t!==Object.prototype&&Object.getPrototypeOf(t)!==null?!1:!(Symbol.iterator in e)&&!(Symbol.toStringTag in e)}var N=U(Tt(),1),je=U(Et(),1);function _(e){return e==null?!1:Array.isArray(e)||typeof e=="string"?!!e.length:m(e)?!!Object.keys(e).length:typeof e=="number"}function me(e){if(typeof e!="string")throw new TypeError("Expected a string");return e.replace(/[|\\{}()[\]^$+*?.]/g,"\\$&").replace(/-/g,"\\x2d")}var Ae=new Map,$t=(e,t)=>{if(!Array.isArray(e))switch(typeof e){case"string":e=[e];break;case"undefined":e=[];break;default:throw new TypeError(`Expected '${t}' to be a string or an array, but got a type of '${typeof e}'`)}return e.filter(r=>{if(typeof r!="string"){if(typeof r>"u")return!1;throw new TypeError(`Expected '${t}' to be an array of strings, but found a type of '${typeof r}' in the array`)}return!0})},mi=(e,t)=>{t=d({caseSensitive:!1},t);let r=e+JSON.stringify(t);if(Ae.has(r))return Ae.get(r);let n=e[0]==="!";n&&(e=e.slice(1)),e=me(e).replace(/\\\*/g,"[\\s\\S]*");let o=new RegExp(`^${e}$`,t.caseSensitive?"":"i");return o.negated=n,Ae.set(r,o),o},Ai=(e,t,r,n)=>{if(e=$t(e,"inputs"),t=$t(t,"patterns"),t.length===0)return[];t=t.map(a=>mi(a,r));let{allPatterns:o}=r||{},i=[];for(let a of e){let u,l=[...t].fill(!1);for(let[b,A]of t.entries())if(A.test(a)&&(l[b]=!0,u=!A.negated,!u))break;if(!(u===!1||u===void 0&&t.some(b=>!b.negated)||o&&l.some((b,A)=>!b&&!t[A].negated))&&(i.push(a),n))break}return i};function z(e,t,r){return Ai(e,t,r,!0).length>0}var _i={arrayVsArrayAllMustBeFound:"any",caseSensitive:!0};function _e(e,t,r){if(!e.length||!t.length)return!1;let n=d(d({},_i),r),o=typeof e=="string"?[e]:Array.from(e);return typeof t=="string"?o.some(i=>z(i,t,{caseSensitive:n.caseSensitive})):n.arrayVsArrayAllMustBeFound==="any"?t.some(i=>o.some(a=>z(a,i,{caseSensitive:n.caseSensitive}))):t.every(i=>o.some(a=>z(a,i,{caseSensitive:n.caseSensitive})))}function Oe(e){return typeof e=="string"}function Oi(e){return typeof e=="number"}function ke(e){return typeof e=="boolean"}var v=Array.isArray;function Mt(e){return!!e&&e.some(t=>typeof t=="string")}function ki(e,t){return Object.keys(e).length===0||Object.keys(t).length===0||Object.keys(e).every(r=>Object.keys(t).includes(r))||Object.keys(t).every(r=>Object.keys(e).includes(r))}function g(e){return e===null?"null":(0,N.default)(e)?"date":m(e)?"object":v(e)?"array":typeof e}var ji={cb:null,mergeObjectsOnlyWhenKeysetMatches:!0,ignoreKeys:[],hardMergeKeys:[],hardArrayConcatKeys:[],mergeArraysContainingStringsToBeEmpty:!1,oneToManyArrayObjectMerge:!1,hardMergeEverything:!1,hardArrayConcat:!1,ignoreEverything:!1,concatInsteadOfMerging:!0,dedupeStringsInArrayValues:!1,mergeBoolsUsingOrNotAnd:!0,useNullAsExplicitFalse:!1};function x(e,t,r,n){var A;let o;if(n.useNullAsExplicitFalse&&(t===null||r===null))return typeof n.cb=="function"?n.cb(t,r,null,{path:e.path,key:e.key,type:e.type}):null;let i=v(t)||m(t)?(0,c.default)(t):t,a=v(r)||m(r)?(0,c.default)(r):r,u;n.ignoreEverything?u=i:n.hardMergeEverything&&(u=a);let l=n.hardMergeEverything||n.ignoreEverything;if(v(i))if(_(i))if(v(a)&&_(a)){if(n.mergeArraysContainingStringsToBeEmpty&&(Mt(i)||Mt(a))){let s=l?u:[];return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:o,key:e.key,type:e.type}):s}if(n.hardArrayConcat){let s=l?u:i.concat(a);return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:o,key:e.key,type:e.type}):s}let f=[];for(let s=0,h=Math.max(i.length,a.length);s<h;s++)o=(A=e.path)!=null&&A.length?`${e.path}.${s}`:`${s}`,m(i[s])&&m(a[s])&&(n.mergeObjectsOnlyWhenKeysetMatches&&ki(i[s],a[s])||!n.mergeObjectsOnlyWhenKeysetMatches)?f.push(x({path:o,key:e.key,type:[g(i),g(a)]},i[s],a[s],n)):n.oneToManyArrayObjectMerge&&(i.length===1||a.length===1)?f.push(i.length===1?x({path:o,key:e.key,type:[g(i),g(a)]},i[0],a[s],n):x({path:o,key:e.key,type:[g(i),g(a)]},i[s],a[0],n)):n.concatInsteadOfMerging?(s<i.length&&f.push(i[s]),s<a.length&&f.push(a[s])):(s<i.length&&f.push(i[s]),s<a.length&&!(0,It.default)(i,a[s])&&f.push(a[s]));n.dedupeStringsInArrayValues&&f.every(s=>Oe(s))&&(f=[...new Set(f)].sort()),i=(0,c.default)(f)}else{let f=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:o,key:e.key,type:e.type}):f}else{if(_(a)){let s=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:o,key:e.key,type:e.type}):s}let f=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:o,key:e.key,type:e.type}):f}else if(m(i)){if(_(i)){if(v(a)){if(_(a)){let p=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),p,{path:o,key:e.key,type:e.type}):p}let h=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),h,{path:o,key:e.key,type:e.type}):h}if(m(a)){Object.keys(a).forEach(p=>{var ve;o=(ve=e.path)!=null&&ve.length?`${e.path}.${p}`:`${p}`,i.hasOwnProperty(p)?_e(p,n.ignoreKeys)?i[p]=x({path:o,key:p,type:[g(i),g(a)]},i[p],a[p],R(d({},n),{ignoreEverything:!0})):_e(p,n.hardMergeKeys)?i[p]=x({path:o,key:p,type:[g(i),g(a)]},i[p],a[p],R(d({},n),{hardMergeEverything:!0})):_e(p,n.hardArrayConcatKeys)?i[p]=x({path:o,key:p,type:[g(i),g(a)]},i[p],a[p],R(d({},n),{hardArrayConcat:!0})):i[p]=x({path:o,key:p,type:[g(i[p]),g(a[p])]},i[p],a[p],n):i[p]=a[p]});let h=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),h,{path:e.path,key:e.key,type:e.type}):i}let s=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}if(v(a)||m(a)||_(a)){let s=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if((0,N.default)(i)){if((0,je.default)(+i)){if((0,N.default)(a)){if((0,je.default)(+a)){let p=l?u:i>a?i:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),p,{path:e.path,key:e.key,type:e.type}):p}let h=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),h,{path:e.path,key:e.key,type:e.type}):h}let s=l?u:a||i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}if((0,N.default)(a)){let s=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if(Oe(i)){if(_(i)){if((v(a)||m(a)||Oe(a))&&_(a)){let h=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),h,{path:e.path,key:e.key,type:e.type}):h}let s=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}if(a!=null&&!ke(a)){let s=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if(Oi(i)){if(_(a)){let s=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if(ke(i)){if(ke(a)){if(n.mergeBoolsUsingOrNotAnd){let h=l?u:i||a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),h,{path:e.path,key:e.key,type:e.type}):h}let s=l?u:i&&a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}if(a!=null){let s=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else if(i===null){if(a!=null){let s=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),s,{path:e.path,key:e.key,type:e.type}):s}let f=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}else{let f=l?u:a;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),f,{path:e.path,key:e.key,type:e.type}):f}let b=l?u:i;return typeof n.cb=="function"?n.cb((0,c.default)(t),(0,c.default)(r),b,{path:e.path,key:e.key,type:e.type}):b}function Pt(e,t,r){var o,i;if(!arguments.length)throw new TypeError("object-merge-advanced/mergeAdvanced(): [THROW_ID_01] Both inputs are missing");let n=d(d({},ji),r);return typeof n.ignoreKeys=="string"&&(n.ignoreKeys=[n.ignoreKeys]),typeof n.hardMergeKeys=="string"&&(n.hardMergeKeys=[n.hardMergeKeys]),(o=n==null?void 0:n.hardMergeKeys)!=null&&o.includes("*")&&(n.hardMergeEverything=!0),(i=n==null?void 0:n.ignoreKeys)!=null&&i.includes("*")&&(n.ignoreEverything=!0),x({key:null,path:"",type:[g(e),g(t)]},e,t,n)}var Dt="4.0.6";var xi=Dt,Bt={dedupe:!0};function Si(e){return Object.keys(e).sort().reduce((t,r)=>(t[r]=e[r],t),{})}function wi(e,t){if(Array.isArray(e)){if(e.length===0)return{}}else throw new Error(`array-of-arrays-into-ast: [THROW_ID_01] inputArr must be array. Currently it's of a type ${typeof e} equal to:
${JSON.stringify(e,null,4)}`);let r=d(d({},Bt),t),n={};return e.forEach(o=>{let i=null;for(let a=o.length;a--;)i={[o[a]]:[i]};n=Pt(n,i,{concatInsteadOfMerging:!r.dedupe})}),Si(n)}return Ht(Ti);})();
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.2.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
/**
 * @name util-nonempty
 * @fileoverview Is the input (plain object, array, string or whatever) not empty?
 * @version 5.0.6
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/util-nonempty/}
 */
/**
 * @name object-merge-advanced
 * @fileoverview Deeply merge JSON-like data structures
 * @version 14.0.6
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/object-merge-advanced/}
 */
